#!/bin/bash
# {{ ansible_managed }}
#
# Show application info of search index application
#

{% if etl_install %}
ETL_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ search_index_etl_downloaddir }}/build.info | cut -d'=' -f2)
ETL_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ search_index_etl_downloaddir }}/build.info | cut -d'=' -f2)
ETL_VERSIONS=$(cat {{ search_index_etl_downloaddir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/oersi-etl/-/tree/${ETL_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/oersi-etl/-/jobs/${ETL_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")
{% else %}
ETL_VERSIONS='"not installed"'
{% endif %}

{% if import_scripts_install %}
IMPORTSCRIPTS_VERSIONS=$(cat {{ search_index_import_scripts_dir }}/build.info | jq -sR "[split(\"\n\")[:-1][] | split(\"=\") | {(.[0]): .[1]}] | add")
{% else %}
IMPORTSCRIPTS_VERSIONS='"not installed"'
{% endif %}

BACKEND_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ tomcat_home }}/webapps/search-index-backend/WEB-INF/classes/build.info | cut -d'=' -f2)
BACKEND_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ tomcat_home }}/webapps/search-index-backend/WEB-INF/classes/build.info | cut -d'=' -f2)
BACKEND_VERSIONS=$(cat {{ tomcat_home }}/webapps/search-index-backend/WEB-INF/classes/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/sidre/sidre-backend/-/tree/${BACKEND_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/sidre/sidre-backend/-/jobs/${BACKEND_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")

if [ -f {{ search_index_schemas_instdir }}/build.info ]; then
  SCHEMAS_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ search_index_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ search_index_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_REPO_URL=$(grep "REPO_URL=" {{ search_index_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_VERSIONS=$(grep -v "^REPO_URL=" {{ search_index_schemas_instdir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=${SCHEMAS_REPO_URL}/-/tree/${SCHEMAS_COMMIT_SHA}\", \"BUILD-JOB=${SCHEMAS_REPO_URL}/-/jobs/${SCHEMAS_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")
else
  SCHEMAS_VERSIONS="{}"
fi

FRONTEND_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ search_index_frontend_instdir }}/build.info | cut -d'=' -f2)
{% if search_index_frontend_features_use_ssr %}
FRONTEND_VERSIONS=$(cat {{ search_index_frontend_instdir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/sidre/sidre-frontend/-/tree/${FRONTEND_COMMIT_SHA}\" | split(\"=\") | {(.[0]): .[1]}] | add")
{% else %}
FRONTEND_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ search_index_frontend_instdir }}/build.info | cut -d'=' -f2)
FRONTEND_VERSIONS=$(cat {{ search_index_frontend_instdir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/sidre/sidre-frontend/-/tree/${FRONTEND_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/sidre/sidre-frontend/-/jobs/${FRONTEND_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")
{% endif %}

read -r -d '' APP_INFO << EOC
{
  "applicationName": "{{ application_name }}",
  "api": {
    "metadataIndexName": "{{ elasticsearch_metadata_index_alias_name }}",
    "metadataEndpoint": "{{ search_index_backend_searchapi_url }}{{ elasticsearch_metadata_index_alias_name }}/",
    "metadataSearchUrl": "{{ search_index_backend_searchapi_url }}{{ elasticsearch_metadata_index_alias_name }}/_search"
  },
  "components": {
    "ETL": $ETL_VERSIONS,
    "Import Scripts": $IMPORTSCRIPTS_VERSIONS,
    "Backend": $BACKEND_VERSIONS,
    "Schemas": $SCHEMAS_VERSIONS,
    "Frontend": $FRONTEND_VERSIONS
  }
}
EOC

jq -n "$APP_INFO"
